﻿ var EdomSettings={
	DefaultRefreshGroup: 1,
	DefaultRefreshRate: 5000,
	DefaultCoverDelay: 500,
	DefaultCoverImage: 'css/loading.gif',
	AddCoverImage: true,
	
	WriteTerminatePrevious:	true,
	WriteFormat: "%d",	
	
	ReadTerminatePrevious:	true,
	ReadTerminatePendingWrite: false,
	ReadTimeout: 5000,
	ReadFormat: "%d"	
};
 
 (function( $ ){
 
	$.extend({
		EdomSetup: function(options) {
			if (options) {EdomSettings = $.extend(EdomSettings, options)}
		},
		
		StartRefreshing: function(options) {
			var options = $.extend({
				refreshrate: EdomSettings.DefaultRefreshRate,
				refreshgroup: EdomSettings.DefaultRefreshGroup
			}, options);			
			$.RefreshData(options.refreshgroup);
			window["Refresher_"+options.refreshgroup]= window.setInterval('$.RefreshData("'+options.refreshgroup+'")',options.refreshrate);
		},
		
		StopRefreshing: function(options) {
			var options = $.extend({
				refreshgroup: EdomSettings.DefaultRefreshGroup
			}, options);		
			window.clearInterval(window["Refresher_"+options.refreshgroup]);	
		},		
		
		RefreshData: function(GroupName) {
			$('[data-refreshgroup='+GroupName+']:visible').RefreshIt();	
		},
	});
	
	$.fn.RefreshIt = function() { 
		return this.each(function() {
			var CurrentField=$(this);
			if (CurrentField.attr('data-read')===undefined) {
				var ErrorMessage='Error at '+CurrentField.attr('id')+', function RefreshIt():\nMissing Read Address';
				alert(ErrorMessage);
			}
			else {
				var ReadParameters = {address: CurrentField.attr('data-read')};
				if (CurrentField.attr('data-readtimeout')!=undefined) {ReadParameters=$.extend({timeout: CurrentField.attr('data-readtimeout')}, ReadParameters)};
				CurrentField.ReadValue(ReadParameters);
			}
		});
	};  //End of RefreshIt function
	
	$.fn.AddButtonCover = function(options) {
		var options = $.extend({
			addimage: 	EdomSettings.AddCoverImage,
			imagefile:	EdomSettings.DefaultCoverImage
		}, options);
		
		return this.each(function() {
			var CurrentButton = $(this);
			
			var CurrentCover = $('<div>', {id: CurrentButton.attr('id')+'_Cover'}).appendTo(CurrentButton);
			CurrentCover.addClass('ButtonCover');
			CurrentCover.css({
					'height': CurrentButton.height(),
					'zIndex': 9999
			});
			
			if (options.addimage) {
				var CurrentImage = $('<img>', {src: options.imagefile}).appendTo(CurrentCover);
				CurrentImage.addClass('CoverImage');
				CurrentImage.load(function(){
					$(this).css({
						marginTop:	-Math.round(this.height/2), 
						marginLeft:	-Math.round(this.width/2) 
					});
				});			
				CurrentButton.data('ButtonCover', CurrentCover);	
			}	
		});	//End of return this....
	};  //End of AddButtonCover function

	$.fn.ShowButtonCover = function(options) {
		var options	= $.extend({
			coverdelay: EdomSettings.DefaultCoverDelay
		}, options);
		return this.each(function() {
			var CurrentButton = $(this);
			var ButtonCoverTimeout = setTimeout('$("#'+CurrentButton.attr('id')+'").addClass("ui-disabled")', options.coverdelay);
			if (CurrentButton.is('div')&&CurrentButton.hasClass('ui-slider')) {
				CurrentButton.slider("disable");
			}
			CurrentButton.data('ButtonCoverTimeout', ButtonCoverTimeout);					
		}); //End of return this....	
	}; //End of ShowButtonCover() function
	
	$.fn.HideButtonCover = function() {
		return this.each(function() {
			var CurrentButton = $(this);
			if (CurrentButton.data('ButtonCoverTimeout')) {
				clearTimeout(CurrentButton.data('ButtonCoverTimeout'));
			}

			if (CurrentButton.hasClass("ui-disabled")) {
				CurrentButton.removeClass("ui-disabled")
			}
			if (CurrentButton.is('div')&&CurrentButton.hasClass('ui-slider')) {
				CurrentButton.slider("enable");
			}			

		});	
	}; //End of HideButtonCover() function
	
	$.fn.WriteValue = function(options) {
		if ((options.address===undefined)||(options.value==undefined)){
			var ErrorMessage='Error at '+this.attr('id')+', function WriteValue():';
			var MissingParameters=true;		
			if (options.address===undefined){ErrorMessage+='\nMissing Write Address'}
			if (options.value===undefined){ErrorMessage+='\nMissing Value'}
		}
		if (MissingParameters) {
			alert(ErrorMessage);
		}
		else {	
			var options	= $.extend({
				terminateprevious:	EdomSettings.WriteTerminatePrevious,
				format: EdomSettings.WriteFormat				
			}, options);
			return this.each(function() {
				var CurrentButton=$(this);			
				if (CurrentButton.data('WriteAjax')!=null){
					if ((CurrentButton.data('WriteAjax').readyState>0) && (CurrentButton.data('WriteAjax').readyState<4)){
						if (options.terminateprevious) {
							CurrentButton.data('WriteAjax').abort();
						}
						else {
							var WritePending=true;
						};	
					};
				};  //End of IF (another Ajax pending)
				if (!WritePending) {
					var AjaxObj = $.ajax({
						type: 'POST',
						url: ServerName+"WRITEPI",
						data: {ADR1: options.address, VALUE1: options.value, FORMAT1: options.format},
						ajaxParent: CurrentButton,
						crossDomain: true,
						successfn: options.successfn,
						success: function(data){
							if (this.successfn!=undefined) {this.successfn.call()}
							else {
								this.ajaxParent.trigger('OnWriteSuccess',[data]);
							}
						}		
					});
					$(this).data('WriteAjax',AjaxObj);				
				};//End of IF (Write is pending)
			});	
		}; //End of IF (Missing parameters)
	}; //End of WriteValue() function
	
	$.fn.ReadValue = function(options) {
		if (!options.address){
			var ErrorMessage='Error at '+this.attr('id')+', function ReadValue():\nMissing Read Address';
			var MissingParameters=true;			
		}
		if (MissingParameters) {
			alert(ErrorMessage);
		}
		else {		
			var options	= $.extend({
				terminateprevious:	EdomSettings.ReadTerminatePrevious,
				terminatependingwrite: EdomSettings.ReadTerminatePendingWrite,
				timeout: EdomSettings.ReadTimeout,
				format: EdomSettings.ReadFormat					
			}, options);
			return this.each(function() {	
				var CurrentField=$(this);
				if (CurrentField.data('WriteAjax')!=null){
					if ((CurrentField.data('WriteAjax').readyState>0) && (CurrentField.data('WriteAjax').readyState<4)){
						if (options.terminatependingwrite) {CurrentField.data('WriteAjax').abort();}
						else {var WritePending=true};	
					}
				}
				if (CurrentField.data('ReadAjax')!=null){
					if ((CurrentField.data('ReadAjax').readyState>0) && (CurrentField.data('ReadAjax').readyState<4)){
						if (options.terminateprevious) {CurrentField.data('ReadAjax').abort()}
						else {var ReadPending=true}
					}
				};
				if (!WritePending && !ReadPending){
					var AjaxObj = $.ajax({
						type: 'POST',
						url: ServerName+"READPI",
						data: {ADR: options.address, FORMAT: options.format},
						timeout: options.timeout,					
						ajaxParent: CurrentField,
						successfn: options.successfn,
						success: function(data, status, xhr){
							if (this.successfn!=undefined) {this.successfn.call()}
							else {					
								this.ajaxParent.trigger('OnReadSuccess',[data]);
							}
						}
					});
					CurrentField.data('ReadAjax',AjaxObj);
				};	
			}); //End of return this....
		}// End of IF (missing parameters)
	} //End of ReadValue() function
	
	$.fn.MakeReadField = function(options) {
		if (!options.read){
			var ErrorMessage='Error at '+this.attr('id')+', function MakeReadField():\nMissing Read Address';
			var MissingParameters=true;			
		}
		if (MissingParameters) {
			alert(ErrorMessage);
		}
		else {
			var options = $.extend({
				refreshgroup: EdomSettings.DefaultRefreshGroup,
				initstatus:		0,
				refreshtype:	'value',
				valuetype:		'text'
			}, options);
			return this.each(function() {
				var CurrentField = $(this);		
				CurrentField.attr('data-read', options.read);			
				CurrentField.attr('data-refreshgroup', options.refreshgroup);
				if (options.readtimeout) {CurrentField.attr('data-readtimeout', options.readtimeout)};	
				if (options.image) {CurrentField.data('ImageToFlip', $('#'+options.image))};
				CurrentField.data('Status', options.initstatus);
				
				if (options.refreshtype==='status') {
					CurrentField.bind('OnReadSuccess', function(event, data){
						var CurrentField = $(this)
						if (CurrentField.data('Status')!= data) { 
							CurrentField.FlipIt();
						}
						return false;
					})
				}			
				if (options.refreshtype==='slider') {
					CurrentField.bind('OnReadSuccess', function(event, data){
						$(this).slider( "option", "value", parseInt(data))
						return false;
					})
				}
				if (options.refreshtype==='value') {
					if (options.valuetype==='temp') {
						CurrentField.bind('OnReadSuccess', function(event, data){					
							if (data>32768) {data-=65536;};
							CurrentField.html('<p>'+(data/10)+'&#176;C</p>');
							return false;						
						})	
					}
					if (options.valuetype==='text') {
						CurrentField.bind('OnReadSuccess', function(event, data){
							CurrentField.html('<p>'+data+'</p>');
							return false;
						})
					}	
				}
			});//End of return this....
		} //End IF (Missing address)
	};// End of MakeReadField
	
	$.fn.MakeWriteButton = function(options) {

		if ((!options.write)||((options.staticvalue===undefined) && (options.dynamicvalue===undefined))) {
			var ErrorMessage='Error at '+this.attr('id')+', function MakeWriteButton():';
			var MissingParameters=true;			
			if (!options.write) {ErrorMessage+='\nMissing Write Address'}
			if ((options.staticvalue===undefined) && (options.dynamicvalue===undefined)) {ErrorMessage+='\nMissing proper Value'}
		}
		if (MissingParameters) {
			alert(ErrorMessage);
		}
		else {
			return this.each(function() {
				var CurrentButton=$(this);
				//CurrentButton.AddButtonCover();
				CurrentButton.attr('data-write', options.write);					
				if (options.coverdelay) {CurrentButton.attr('data-coverdelay', options.coverdelay)};
				if (options.staticvalue!=undefined){
					CurrentButton.attr('data-value', options.staticvalue);
				}
				else {
					CurrentButton.data('ValueHolder', $('#'+options.dynamicvalue));
				}
				if (options.refreshonwrite!=undefined) {
					CurrentButton.data('RefreshOnWrite', $('#'+options.refreshonwrite));
				}
				
				CurrentButton.click(function(){
					var CurrentButton = $(this);
					if (CurrentButton.attr('data-value')!=undefined) {
						var ValueToWrite = CurrentButton.attr('data-value');
					}
					else if (CurrentButton.data('ValueHolder')!=undefined) {
						var ValueHolder=CurrentButton.data('ValueHolder');
						if (ValueHolder.is('div')) {
							if (ValueHolder.hasClass('ui-slider')){var ValueToWrite=ValueHolder.slider( "option", "value" )}
							else {var ValueToWrite = ValueHolder.text()}
						}
						if (ValueHolder.is('input')) {var ValueToWrite = ValueHolder.val()}
					};
					if (ValueToWrite!=undefined){
						CurrentButton.ShowButtonCover();
						CurrentButton.WriteValue({
							address: CurrentButton.attr('data-write'),
							value: ValueToWrite,
						});
					};	
					return false;
				}); //End of Click functions
				
				CurrentButton.bind('OnWriteSuccess', function(){
					var CurrentButton=$(this);
					CurrentButton.HideButtonCover();
					if (CurrentButton.data('RefreshOnWrite')) {
						CurrentButton.data('RefreshOnWrite').RefreshIt();
					}
					return false;
				});
			});//End of return this
		}; // End of IF (Missing parameters)
	}; //End of MakeWriteButton function
	
	$.fn.MakeTapButton = function(options) {
		
		if ((options.write===undefined)||(options.read===undefined)) {
			ErrorMessage='Error at '+this.attr('id')+', function MakeTapButton():';
			if (options.write===undefined) {ErrorMessage+='\nMissing Write Address'}
			if (options.read===undefined) {ErrorMessage+='\nMissing Read Address'}
			var MissingParameters=true;
		}
		if (MissingParameters) {
			alert(ErrorMessage);
		}
		else {
			var options = $.extend({
				refreshgroup: EdomSettings.DefaultRefreshGroup,			
				initstatus:		0,
				tapduration:	0
			}, options);
			return this.each(function() {		
				var CurrentButton=$(this);
				//CurrentButton.AddButtonCover();
				
				CurrentButton.attr('data-write', options.write);		
				CurrentButton.attr('data-refreshgroup', options.refreshgroup);
				CurrentButton.attr('data-read', options.read);				
				if (options.coverdelay!=undefined) {CurrentButton.attr('data-coverdelay', options.coverdelay)}
				if (options.readtimeout!=undefined) {CurrentButton.attr('data-readtimeout', options.readtimeout)}
				CurrentButton.attr('data-tapduration', options.tapduration);
			
				if (options.image != undefined) {CurrentButton.data('ImageToFlip', $('#'+options.image))}
				CurrentButton.data('Status', options.initstatus);
				
				CurrentButton.click(function(){
					CurrentButton=$(this);
					CurrentButton.ShowButtonCover();				
					CurrentButton.WriteValue({
						address: CurrentButton.attr('data-write'),
						value: 1
					});
				});
				
				CurrentButton.bind('OnWriteSuccess',function(event, data){
					CurrentButton=$(this);
					setTimeout('$("#'+CurrentButton.attr('id')+'").WriteValue({address: "'+CurrentButton.attr('data-write')+'", value: 0, successfn: function(){$("#'+CurrentButton.attr('id')+'").HideButtonCover()}})',(CurrentButton.data('Status')==0)?CurrentButton.attr('data-tapduration'):0);
					CurrentButton.FlipIt();
					return false;
				});
				
				CurrentButton.bind('OnReadSuccess', function(event, data){
					var CurrentField = $(this);					
					if (CurrentField.data('Status')!= data) { 
						CurrentField.FlipIt();
					}
					return false;
				});	
			});//End of return this...
		} //End if (missing parameters)
	};  //End of MakeAjaxButton function

	
	$.fn.FlipIt = function() { 
		return this.each(function() {	
			$(this).data('Status', Math.abs($(this).data('Status')-1));
			if ($(this).data('ImageToFlip')) {
				var ImageName=$(this).data('ImageToFlip').attr('src');
				var ImageExtension=ImageName.substring(ImageName.length-4);
				ImageName=ImageName.substring(0,ImageName.length-5);
				$(this).data('ImageToFlip').attr('src',ImageName+$(this).data('Status')+ImageExtension);
			}	
			($(this).data('Status')==0) ?	$(this).removeClass('flipped'):$(this).addClass('flipped');
		});
	};  //End of FlipIt function	
})( jQuery );